using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace PruebaGDBG
{
    public partial class Form1 : Form
    {
        DataTable dt;
        bool bEdicion = false;
        ComboBox cbo;
        int iLastColIndex;

        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.DoEvents();
            Application.Run(new Form1());
        }

        public Form1()
        {
            InitializeComponent();
            cbo = new ComboBox();
            this.grid.DefaultRowHeight = cbo.Height;

            //dt = new DataTable();
            //dt.Columns.Add("Entero", Type.GetType("System.Int32"));
            //dt.Columns.Add("Doble", Type.GetType("System.Double"));
            //dt.Columns.Add("Doble2", Type.GetType("System.Double"));
            //dt.Columns.Add("Cadena", Type.GetType("System.String"));
            //dt.Columns.Add("Booleano", Type.GetType("System.Boolean"));
            //dt.Columns.Add("Boton", Type.GetType("System.Int32"));

            DataSet ds = new dsTest();
            dt = ds.Tables[0];

            Random r = new Random();
            bool b = true;

            for(int i = 0; i<10; i++){
                DataRow dr = dt.NewRow();
                dr["Entero"] = r.Next();
                dr["Doble"] = r.NextDouble();
                dr["Doble2"] = r.NextDouble();
                dr["Booleano"] = b;
                b=!b;
                dr["Boton"] = r.Next();
                dt.Rows.Add(dr);
            }

            this.grid.Model.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(Model_QueryCellInfo);

            AddColumn("Entero", "Column1", this.grid, GridHorizontalAlignment.Left, true);
            AddColumn("Doble", "Column2", this.grid, GridHorizontalAlignment.Left, true);
            AddColumn("Doble2", "Column3", this.grid, GridHorizontalAlignment.Left, true);
            AddColumn("Cadena", "Column4", this.grid, GridHorizontalAlignment.Left, true);
            AddColumn("Booleano", "Column5", this.grid, GridHorizontalAlignment.Left, true);
            AddColumn("Boton", "Column6", this.grid, GridHorizontalAlignment.Left, true);

            this.grid.GridBoundColumns[1].StyleInfo.CellType = "Currency";
            this.grid.GridBoundColumns[1].StyleInfo.CurrencyEdit.CurrencyDecimalDigits = 2;
            this.grid.GridBoundColumns[1].StyleInfo.CurrencyEdit.CurrencyNegativePattern = 8;
            this.grid.GridBoundColumns[1].StyleInfo.CurrencyEdit.CurrencyPositivePattern = 3;
            this.grid.GridBoundColumns[1].StyleInfo.CurrencyEdit.CurrencySymbol = " ";
            this.grid.GridBoundColumns[2].StyleInfo.CellType = "Currency";
            this.grid.GridBoundColumns[2].StyleInfo.CurrencyEdit.CurrencyDecimalDigits = 2;
            this.grid.GridBoundColumns[2].StyleInfo.CurrencyEdit.CurrencyNegativePattern = 8;
            this.grid.GridBoundColumns[2].StyleInfo.CurrencyEdit.CurrencyPositivePattern = 3;
            this.grid.GridBoundColumns[2].StyleInfo.CurrencyEdit.CurrencySymbol = " ";

            this.grid.DataSource = dt.DefaultView;           
            
        }

        void grid_CurrentCellActivating(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellActivatingEventArgs e)
        {
            if (!bEdicion || e.RowIndex != 1)
                e.Cancel = true;
        }

        void grid_CellButtonClicked(object sender, Syncfusion.Windows.Forms.Grid.GridCellButtonClickedEventArgs e)
        {
            this.grid.CurrentCell.EndEdit();
            bEdicion = false;
            dt.Rows[0].EndEdit();            
            this.grid.DataSource = null;            
            this.grid.DataSource = dt.DefaultView;
        }

        void Model_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            if (bEdicion && e.RowIndex ==1)
            {
                switch (e.ColIndex)
                {
                    case 4:
                        GridCurrentCell cc = this.grid.CurrentCell;
                        if (cc.ColIndex == 4)
                        {
                            e.Style.CellType = "Control";
                            e.Style.Control = cbo;

                            if (!cbo.Visible)
                            {
                                cbo.Visible = true;
                                cbo.Enabled = true;
                                e.Style.CellValue = cbo.Text;
                            }
                        }
                        else
                        {
                            e.Style.CellType = "Static";
                            cbo.Visible = false;
                            e.Style.CellValue = cbo.Text;
                        }
                        break;
                    case 6:
                        e.Style.Description = "A";
                        e.Style.CellType = "PushButton";
                        break;
                }
            }
        }

        void grid_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            GridCurrentCell cc = this.grid.CurrentCell;

            if (bEdicion && cc.RowIndex == 1){
                if (e.KeyChar == Convert.ToChar(Keys.Enter)){                    
                    if (cc.ColIndex == 7) //Current cell ya es la siguente
                    grid_CellButtonClicked(null, null);
                }
                if (e.KeyChar == Convert.ToChar(Keys.Space)){
                    if (cc.ColIndex == 6) //Current cell ya es la siguente
                    grid_CellButtonClicked(null, null);
                }
            }
        }

        private void btnEdicion_Click(object sender, EventArgs e)
        {
            if (!bEdicion)
            {
                dt.Rows[0].BeginEdit();                
                bEdicion = true;
                this.grid.CurrentCell.MoveTo(1, 1, GridSetCurrentCellOptions.SetFocus);
                this.grid.Refresh();
            }
        }

        private void AddColumn(string sMappingName, string sTitle, GridDataBoundGrid oGrid, GridHorizontalAlignment oAligment, bool bEditable)
        {
            Syncfusion.Windows.Forms.Grid.GridBoundColumn laColumna;

            laColumna = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
            laColumna.MappingName = sMappingName;
            laColumna.HeaderText = sTitle;
            laColumna.ReadOnly = !bEditable;
            laColumna.StyleInfo.AutoSize = true;
            laColumna.StyleInfo.HorizontalAlignment = oAligment;
            oGrid.GridBoundColumns.Add(laColumna);
        }

        //private void grid_CurrentCellMoved(object sender, EventArgs e)
        //{
        //    //GridCurrentCell cc = this.grid.CurrentCell;
        //    //if (bEdicion && cc.ColIndex == 4 && cc.RowIndex == 1 && cbo != null)
        //    //    //cbo.Focus();
        //    //    this.grid.CurrentCell.MoveTo(1, 4, GridSetCurrentCellOptions.SetFocus);
        //}

        void grid_CurrentCellMoving(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMovingEventArgs e)
        {
            e.Cancel = !IsValidMove;
            if (!IsValidMove)
                IsValidMove = true;

            GridCurrentCell cc = this.grid.CurrentCell;            
            //if (cc.ColIndex != e.ColIndex || cc.RowIndex != e.RowIndex)
            //{
            //    e.Cancel
            //    this.grid.CurrentCell.MoveTo(e.RowIndex, e.ColIndex, GridSetCurrentCellOptions.SetFocus);
            //}

            //grid.CurrentCell.IsModified = true;

            iLastColIndex = cc.ColIndex;
        }
        bool IsValidMove = true;
        private void grid_CurrentCellMoved(object sender, GridCurrentCellMovedEventArgs e)
        {
            GridCurrentCell cc = this.grid.CurrentCell;
                       
            switch (cc.MoveToColIndex)
            {
                case 3:
                    if (grid[cc.RowIndex, 2].CellValue != "" && Convert.ToDouble(grid[cc.RowIndex, 2].CellValue) != 0)
                    {
                        if (iLastColIndex < 3)
                        {
                            cc.MoveRight();
                            if (e.Options != (GridSetCurrentCellOptions.ScrollInView | GridSetCurrentCellOptions.NoSelectRange))
                                IsValidMove = false;
                          
                        }
                        else
                        {
                            cc.MoveLeft();
                            if (e.Options != (GridSetCurrentCellOptions.ScrollInView | GridSetCurrentCellOptions.NoSelectRange) )
                                IsValidMove = false;
                          
                         
                        }
                    }
                    break;
                case 4:
                    GridStyleInfo style = this.grid.Model[cc.RowIndex, cc.ColIndex];
                    GridQueryCellInfoEventArgs arg = new GridQueryCellInfoEventArgs(cc.RowIndex, cc.ColIndex, style);
                    grid.Model.RaiseQueryCellInfo(arg);
                    this.cbo.Select();
                    break;
            }
        }

       
     
        //void grid_CurrentCellAcceptedChanges(object sender, System.ComponentModel.CancelEventArgs e)
        //{
        //    GridCurrentCell cc = this.grid.CurrentCell;
        //    //if (cc.ColIndex != e.ColIndex || cc.RowIndex != e.RowIndex)                            
        //        this.grid.CurrentCell.MoveTo(cc.RowIndex, cc.ColIndex, GridSetCurrentCellOptions.SetFocus);
            
        //}
    }
}